洛谷 P1137 旅行计划 :拓扑dp

旅行计划:

在这里插入图片描述

题解:

由于拓扑排序是具有后效性的,所以我们可以先求出图的拓扑序,然后再对拓扑的地方进行dp即可,显然可以得到dp转移方程 dp[v]=max(dp[u]+1,dp[v]);

AC代码:

#include<bits/stdc++.h>
using namespace std;
const int maxn=1e6+5;
#define ll long long
struct node
{
    ll to,nex;
} edge[maxn];
ll head[maxn],in[maxn],dp[maxn],a[maxn];
ll cnt,id,n;
void add(ll u,ll v)
{
    edge[cnt].to=v;
    edge[cnt].nex=head[u];
    head[u]=cnt++;
}
void topsort()
{
    queue<ll>q;
    for(ll i=1; i<=n; i++)
    {
        if(!in[i])
        {
            q.push(i);
            a[++id]=i;
        }
    }
    while(!q.empty())
    {
        ll u=q.front();
        q.pop();
        for(ll i=head[u]; ~i; i=edge[i].nex)
        {
            ll v=edge[i].to;
            in[v]--;
            if(!in[v])
            {
                q.push(v);
                a[++id]=v;
            }
        }
    }

}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    memset(head,-1,sizeof(head));
    ll m,u,v;
    cin>>n>>m;
    for(ll i=1; i<=m; i++)
    {
        cin>>u>>v;
        add(u,v);
        in[v]++;
    }
    topsort();
    for(int i=1;i<=n;i++)
    {
        dp[i]=1;
    }
    for(ll i=1; i<=id; i++)
    {
        for(int j=head[a[i]];~j;j=edge[j].nex)
        {
           int v=edge[j].to;
           dp[v]=max(dp[v],dp[a[i]]+1);
        }
    }
    for(int i=1;i<=n;i++)
    {
        cout<<dp[i]<<endl;
    }
}
  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值